''
''            **************************Thermocouple Project -- Dr.Rao ******************************************
''
''                                 Date/Thermocouples/SD Card  Intergrated  - STARTED THE TEST - Updated 12/12/13 -18hr.12min.
''                                  PROGRAMED TO THE EEPROM
''
CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

       cspinK   = 2
       cspinJ1  = 4
       cspinJ2 = 5
       sckpin  = 1
       misopin = 3

      _i2cSDA      = 8
      _i2cSCL     = 7                                      'DS1307_Address := _deviceAddress

      DS1307_Address  = %1101_0000  
         
      _clockDataPin = 20          ' changed to 20   from 2
      _clockClockPin = 19        'changed to  19   from 1

      Lcdpin = 6
      Baud   = 19200
      Lines  = 4

      ' #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control 

        
VAR
  long  TempJ1,TempJ2,TempK
  long  TimeStack[100]
  long  ThermoStack[100]
  byte  Day1, Month1, Year1, Hour1, Minute1, secs1
  
   
OBJ
    Therm1      : "jm_max31855"
    Therm2      : "jm_max31855"
    Therm3      : "jm_max31855" 
    LCD         : "Debug_Lcd"
    RTC         : "DS1307Obj"
    sd          : "fsrw"
   

    
PUB Start

         
         lcd.init(Lcdpin, Baud, Lines)
      
         cognew(Time,@TimeStack)
         waitcnt(clkfreq+ cnt)
         cognew(Thermocouple,@ThermoStack)

         SdCard 

         



Pub SDCard


     sd.mount(18)
     sd.opendir

 'Repeat  'while   Hour1 == 6 or Hour1 == 12 or Hour1 == 18 and Hour1 == 24  and  Minute1 ==0 and secs1 == 0 
   'waitcnt((clkfreq+cnt)
   
    repeat   
   
      If Hour1 == 16 or Hour1 == 17 or Hour1 == 18 and Hour1 == 19  and  Minute1 == 0 and secs1 == 0
     
        sd.popen(string("Thermo.txt"), "a")  'open file name "Thermo.txt" to append
      'get and write date to SDCard
        sd.sdstr(string("DATE:"))
        sd.sddec(Month1)      ' gets the month and puts it to the variable "Month1
        sd.sdstr(string("/")) 
        sd.sddec(Day1)
        sd.sdstr(string("/"))
        sd.sddec(Year1)
        ' get and write to SDCard 
        sd.sdstr(string("  TIME:"))
        sd.sddec(Hour1)
        sd.sdstr(string(":"))
        sd.sddec(Minute1)
        sd.sdstr(string(":"))
        sd.sddec(Secs1)
    '   'get Thermocouples A,B & C Temps
        sd.sdstr(string(" --> Temps :"))
        sd.sdstr(string("A:"))
        sd.sddec((TempJ1))                         
        sd.sdstr(string(" B:"))                     
        sd.sddec(TempJ2)
        sd.sdstr(string(" C:"))
        sd.sddec(TempK)
        sd.pputc(13)                                
        sd.pputc(10)
        sd.pputc(13)                                
        sd.pputc(10)
        sd.pclose
        'quit
        'waitcnt(clkfreq+cnt* 300)    'log every 5 mins.
       

     
pub Time  | Days,Months,Years,secs  

     RTC.init(DS1307_Address,_i2cSDA, _i2cSCL,false)
     lcd.init(Lcdpin, Baud, Lines)                                                             
     lcd.backLight(true) 
                                  
              ' start lcd
    lcd.cursor(0)                                       ' cursor off
    lcd.backLight(true)
    lcd.cls                                ' backlight on (if available)
    waitcnt(clkfreq+cnt)
    'lcd.str(string("Date:"))
   
  secs := RTC.gettime
  if secs == 80
    ' the clock has not been initialised so lets set it
    ' this will demonstrate hour & day roleover. 
    RTC.settime(23,59,45)  ' 23:59:45
    RTC.setdate(1,1,5,06)  ' 1/5/2006 - day 1  

  
  repeat 
   
   lcd.cls
    
    ' get and display the DATE
    lcd.str(string("DATE:"))    
    RTC.getdate
    Month1:= (RTC.getMonths)
    lcd.dec(Month1)
    lcd.str(string("/"))
    Day1:=(RTC.getDays)
    Lcd.dec(Day1)
    lcd.str(string("/"))                                       
    Year1:=(RTC.getYears)
    Lcd.dec(Year1)
     ' get and display the TIME
    lcd.putc($0D)
    lcd.str(string("TIME: "))
    RTC.gettime
    Hour1:=(RTC.getHours)
    lcd.dec(Hour1)
    lcd.str(string(":"))
    Minute1:=(RTC.getMinutes)
    Lcd.dec(Minute1)
    lcd.str(string(":"))                                       
    Secs1:=(RTC.getSeconds)
    lcd.dec(Secs1)
    lcd.putc($0D)
    lcd.putc($0D)
    lcd.str(string("A:"))
    lcd.dec(TempJ1)
    lcd.str(string("  B:"))
    lcd.dec(TempJ2)
    lcd.str(string("  C:"))
    lcd.dec(TempK) 
    ' wait a tick or two
    waitcnt(60_000_000+cnt)
   
Pub Thermocouple

      
        Therm1.start(cspinJ1, sckpin, misopin, -1)         'Setup IO for max31855
        Therm2.start(cspinJ2, sckpin, misopin,-1)
        Therm3.start(cspinK, sckpin, misopin,-1)
   Repeat
        TempJ1 := 32 +(Therm1.read_tc (True)*9 /5)    ' converting to F
        TempJ2 := 32+ (Therm2.read_tc (True)*9/5)
        TempK := 32+(Therm3.read_tc (True)* 9/5)
        waitcnt(clkfreq + cnt)



     